(function() {
  var FormatJSTime, FormatMonth, FormatTime, Friendly, FriendlyDate, StdDate,
    __indexOf = Array.prototype.indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; },
    __slice = Array.prototype.slice;

  window.FriendlyDate = FriendlyDate = (function() {

    function FriendlyDate(friendly_date) {
      var all, _ref, _ref2, _ref3, _ref4;
      this.friendly_date = friendly_date;
      _ref = this.parseDateTime(this.friendly_date), all = _ref[0], this.date = _ref[1], this.time = _ref[2];
      this.date_length = this.date.length;
      if (this.date_length > 9) {
        _ref2 = this.parseDate(this.date), all = _ref2[0], this.verbose_day = _ref2[1], this.day = _ref2[2], this.verbose_month = _ref2[3], this.year = _ref2[4];
      }
      if (__indexOf.call(this.time, ":") >= 0) {
        _ref3 = this.parseTime(this.time), all = _ref3[0], this.hour = _ref3[1], this.minutes = _ref3[2], this.period = _ref3[3];
        this.time = (new FormatJSTime(this.hour, this.minutes, this.period)).toJS();
      } else {
        _ref4 = this.parseShortTime(this.time), all = _ref4[0], this.hour = _ref4[1], this.period = _ref4[2];
        this.time = (new FormatJSTime(this.hour, this.period)).toJS();
      }
    }

    FriendlyDate.prototype.parseDateTime = function(friendlyDate) {
      var r, result, _i, _len, _results;
      result = friendlyDate.match(/(.*)at(.*)/);
      _results = [];
      for (_i = 0, _len = result.length; _i < _len; _i++) {
        r = result[_i];
        _results.push(r.trim());
      }
      return _results;
    };

    FriendlyDate.prototype.parseDate = function(date) {
      var pattern, r, result, _i, _len, _results;
      pattern = /(\w+)\sthe\s(\d{1,2})\w+\sof\s(\w+)\s(\d{4})/;
      result = date.match(pattern);
      _results = [];
      for (_i = 0, _len = result.length; _i < _len; _i++) {
        r = result[_i];
        _results.push(r.trim());
      }
      return _results;
    };

    FriendlyDate.prototype.parseTime = function(time) {
      var pattern, r, result, _i, _len, _results;
      pattern = /(\d{1,2}):(\d{2})(\w{2})/;
      result = time.match(pattern);
      _results = [];
      for (_i = 0, _len = result.length; _i < _len; _i++) {
        r = result[_i];
        _results.push(r.trim());
      }
      return _results;
    };

    FriendlyDate.prototype.parseShortTime = function(time) {
      var pattern, r, result, _i, _len, _results;
      pattern = /(\d{1,2})(\w{2})/;
      result = time.match(pattern);
      _results = [];
      for (_i = 0, _len = result.length; _i < _len; _i++) {
        r = result[_i];
        _results.push(r.trim());
      }
      return _results;
    };

    FriendlyDate.prototype.toJS = function() {
      var all, date, pattern, _ref, _ref2, _ref3;
      pattern = /(.*)\d{2}:\d{2}:\d{2}.*/;
      switch (this.date_length) {
        case 5:
          date = new Date();
          _ref = date.toString().match(pattern), all = _ref[0], date = _ref[1];
          return "" + date + " " + this.time;
        case 8:
          date = new Date();
          date = new Date(date.getTime() + 86400000);
          _ref2 = date.toString().match(pattern), all = _ref2[0], date = _ref2[1];
          return "" + date + " " + this.time;
        case 9:
          date = new Date();
          date = new Date(date.getTime() - 86400000);
          _ref3 = date.toString().match(pattern), all = _ref3[0], date = _ref3[1];
          return "" + date + " " + this.time;
        default:
          return "" + (this.verbose_day.substr(0, 3)) + " " + (this.verbose_month.substr(0, 3)) + " " + this.day + " " + this.year + " " + this.time;
      }
    };

    FriendlyDate.prototype.toJSON = function() {
      return {
        friendly_date: this.friendly_date,
        js_date: this.toJS()
      };
    };

    return FriendlyDate;

  })();

  window.StdDate = StdDate = (function() {

    function StdDate(rawDateTime) {
      var all, _ref;
      _ref = this.parseRawDate(rawDateTime.toString()), all = _ref[0], this.verbose_day = _ref[1], this.verbose_month = _ref[2], this.day = _ref[3], this.year = _ref[4], this.hour = _ref[5], this.minutes = _ref[6];
      this.month = (new FormatMonth(this.verbose_month)).toIndex();
      this.time = (new FormatTime(this.hour, this.minutes)).toFriendly();
      this.date = new Date(this.year, this.month, this.day);
      this.date = new Friendly(this.date);
    }

    StdDate.prototype.parseRawDate = function(rawDateTime) {
      var pattern, r, result, _i, _len, _results;
      if (rawDateTime == null) rawDateTime = "";
      pattern = /(\w{3})\s(\w{3})\s(\d{2})\s(\d{4})\s(\d{2}):(\d{2})/;
      result = rawDateTime.match(pattern);
      _results = [];
      for (_i = 0, _len = result.length; _i < _len; _i++) {
        r = result[_i];
        _results.push(r.trim());
      }
      return _results;
    };

    StdDate.prototype.toFriendly = function() {
      return "" + (this.date.toFriendly()) + " at " + this.time;
    };

    StdDate.prototype.toJSON = function() {
      return {
        friendly_date: this.toFriendly(),
        js_date: "" + this.verbose_day + " " + this.verbose_month + " " + this.day + " " + this.year + " " + this.hour + ":" + this.minutes + ":00"
      };
    };

    return StdDate;

  })();

  window.FormatMonth = FormatMonth = (function() {

    function FormatMonth(verbose_month) {
      this.verbose_month = verbose_month;
    }

    FormatMonth.prototype.toIndex = function() {
      var months;
      months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
      return months.indexOf(this.verbose_month);
    };

    return FormatMonth;

  })();

  window.FormatTime = FormatTime = (function() {

    function FormatTime(hour, minutes) {
      this.hour = hour;
      this.minutes = minutes;
    }

    FormatTime.prototype.toFriendly = function() {
      var am, hours, minutes, period, _ref, _ref2;
      hours = {
        '00': "12",
        '01': "1",
        '02': "2",
        '03': "3",
        '04': "4",
        '05': "5",
        '06': "6",
        '07': "7",
        '08': "8",
        '09': "9",
        '10': "10",
        '11': "11",
        '12': "12",
        '13': "1",
        '14': "2",
        '15': "3",
        '16': "4",
        '17': "5",
        '18': "6",
        '19': "7",
        '20': "8",
        '21': "9",
        '22': "10",
        '23': "11"
      };
      am = ['00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11'];
      minutes = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
      period = (_ref = this.hour, __indexOf.call(am, _ref) >= 0) ? "am" : "pm";
      this.minutes = (_ref2 = this.minutes, __indexOf.call(minutes, _ref2) >= 0) ? "0" + this.minutes : this.minutes;
      if (this.minutes === "00") {
        return "" + hours[this.hour] + period;
      } else {
        return "" + hours[this.hour] + ":" + this.minutes + period;
      }
    };

    return FormatTime;

  })();

  window.FormatJSTime = FormatJSTime = (function() {

    function FormatJSTime() {
      var time;
      time = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
      if (time.length === 3) {
        this.hour = time[0];
        this.minutes = time[1];
        this.period = time[2];
      } else {
        this.hour = time[0];
        this.period = time[1];
      }
    }

    FormatJSTime.prototype.toJS = function() {
      var hours;
      hours = {
        "am": {
          "12": "00",
          "1": "01",
          "2": "2",
          "02": "02",
          "3": "03",
          "4": "04",
          "5": "05",
          "6": "06",
          "7": "07",
          "8": "08",
          "9": "09",
          "10": "10",
          "11": "11"
        },
        "pm": {
          "12": "12",
          "1": "13",
          "2": "14",
          "3": "15",
          "4": "16",
          "5": "17",
          "6": "18",
          "7": "19",
          "8": "20",
          "9": "21",
          "10": "22",
          "11": "23"
        }
      };
      if (this.minutes) {
        return "" + hours[this.period][this.hour] + ":" + this.minutes + ":00";
      } else {
        return "" + hours[this.period][this.hour] + ":00:00";
      }
    };

    return FormatJSTime;

  })();

  window.Friendly = Friendly = (function() {

    function Friendly(date) {
      this.date = date;
      this.today = new Date();
    }

    Friendly.prototype.toFriendly = function() {
      var days, friendlyDays, months;
      switch (this.date.toDateString()) {
        case this.today.toDateString():
          return "Today";
        case (new Date(this.today.getTime() + 86400000)).toDateString():
          return "Tomorrow";
        case (new Date(this.today.getTime() - 86400000)).toDateString():
          return "Yesterday";
        default:
          days = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
          friendlyDays = ["1st", "2nd", "3rd", "4th", "5th", "6th", "7th", "8th", "9th", "10th", "11th", "12th", "13th", "14th", "15th", "16th", "17th", "18th", "19th", "20th", "21st", "22nd", "23rd", "24th", "25th", "26th", "27th", "28th", "29th", "30th", "31st"];
          months = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
          return "" + days[this.date.getDay()] + " the " + friendlyDays[this.date.getDate() - 1] + " of " + months[this.date.getMonth()] + " " + (this.date.getFullYear());
      }
    };

    return Friendly;

  })();

}).call(this);
